/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.daos;


import com.tabajara.base.tables.Funcionario;
import com.tabajara.base.tables.records.FuncionarioRecord;

import io.github.jklingsporn.vertx.jooq.shared.internal.AbstractVertxDAO;

import java.util.List;

import javax.annotation.Generated;

import org.jooq.Configuration;


import io.vertx.core.Future;
import io.github.jklingsporn.vertx.jooq.classic.jdbc.JDBCClassicQueryExecutor;
/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class FuncionarioDao extends AbstractVertxDAO<FuncionarioRecord, com.tabajara.base.tables.pojos.Funcionario, String, Future<List<com.tabajara.base.tables.pojos.Funcionario>>, Future<com.tabajara.base.tables.pojos.Funcionario>, Future<Integer>, Future<String>> implements io.github.jklingsporn.vertx.jooq.classic.VertxDAO<FuncionarioRecord,com.tabajara.base.tables.pojos.Funcionario,String> {

    /**
     * @param configuration The Configuration used for rendering and query execution.
     * @param vertx the vertx instance
     */
    public FuncionarioDao(Configuration configuration, io.vertx.core.Vertx vertx) {
        super(Funcionario.FUNCIONARIO, com.tabajara.base.tables.pojos.Funcionario.class, new JDBCClassicQueryExecutor<FuncionarioRecord,com.tabajara.base.tables.pojos.Funcionario,String>(com.tabajara.base.tables.pojos.Funcionario.class,configuration,vertx), configuration);
    }

    /**
     * {@inheritDoc}
     */
    @Override
    protected String getId(com.tabajara.base.tables.pojos.Funcionario object) {
        return object.getFunmatricula();
    }

    /**
     * Find records that have <code>funnome IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Funcionario>> findManyByFunnome(List<String> values) {
        return findManyByCondition(Funcionario.FUNCIONARIO.FUNNOME.in(values));
    }

    /**
     * Find records that have <code>funcpf IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Funcionario>> findManyByFuncpf(List<String> values) {
        return findManyByCondition(Funcionario.FUNCIONARIO.FUNCPF.in(values));
    }

    /**
     * Find records that have <code>funsexo IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Funcionario>> findManyByFunsexo(List<String> values) {
        return findManyByCondition(Funcionario.FUNCIONARIO.FUNSEXO.in(values));
    }

    /**
     * Find records that have <code>funativo IN (values)</code> asynchronously
     */
    public Future<List<com.tabajara.base.tables.pojos.Funcionario>> findManyByFunativo(List<String> values) {
        return findManyByCondition(Funcionario.FUNCIONARIO.FUNATIVO.in(values));
    }
}
